# Class VulkanLayerProperties

java.lang.Object
com.io7m.jcoronado.api.VulkanLayerProperties

All Implemented Interfaces:
  `VulkanLayerPropertiesType`

public final class VulkanLayerProperties extends Object implements VulkanLayerPropertiesType
A description of a layer.

See Also:
  - "VkLayerProperties"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanLayerProperties.Builder`
  Builds instances of type `VulkanLayerProperties`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanLayerProperties.Builder`
  `builder()`
  Creates a builder for `VulkanLayerProperties`.
  `static VulkanLayerProperties`
  `copyOf(VulkanLayerPropertiesType instance)`
  Creates an immutable copy of a `VulkanLayerPropertiesType` value.
  `String`
  `description()`
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanLayerProperties` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `name`, `description`, `specificationVersion`, `implementationVersion`.
  `int`
  `implementationVersion()`
  `String`
  `name()`
  `static VulkanLayerProperties`
  `of(String name, String description, int specificationVersion, int implementationVersion)`
  Construct a new immutable `VulkanLayerProperties` instance.
  `int`
  `specificationVersion()`
  `String`
  `toString()`
  Prints the immutable value `VulkanLayerProperties` with attribute values.
  `final VulkanLayerProperties`
  `withDescription(String value)`
  Copy the current immutable object by setting a value for the `description` attribute.
  `final VulkanLayerProperties`
  `withImplementationVersion(int value)`
  Copy the current immutable object by setting a value for the `implementationVersion` attribute.
  `final VulkanLayerProperties`
  `withName(String value)`
  Copy the current immutable object by setting a value for the `name` attribute.
  `final VulkanLayerProperties`
  `withSpecificationVersion(int value)`
  Copy the current immutable object by setting a value for the `specificationVersion` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### name

    public String name()
    Specified by:
      `name` in interface `VulkanLayerPropertiesType`
    Returns:
      The name of the layer

  - ### description

    public String description()
    Specified by:
      `description` in interface `VulkanLayerPropertiesType`
    Returns:
      A humanly-readable description of the layer

  - ### specificationVersion

    public int specificationVersion()
    Specified by:
      `specificationVersion` in interface `VulkanLayerPropertiesType`
    Returns:
      The version of the specification defining this layer

  - ### implementationVersion

    public int implementationVersion()
    Specified by:
      `implementationVersion` in interface `VulkanLayerPropertiesType`
    Returns:
      The version of the layer implementation

  - ### withName

    public final VulkanLayerProperties withName(String value)
    Copy the current immutable object by setting a value for the `name` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for name
    Returns:
      A modified copy of the `this` object

  - ### withDescription

    public final VulkanLayerProperties withDescription(String value)
    Copy the current immutable object by setting a value for the `description` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for description
    Returns:
      A modified copy of the `this` object

  - ### withSpecificationVersion

    public final VulkanLayerProperties withSpecificationVersion(int value)
    Copy the current immutable object by setting a value for the `specificationVersion` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for specificationVersion
    Returns:
      A modified copy of the `this` object

  - ### withImplementationVersion

    public final VulkanLayerProperties withImplementationVersion(int value)
    Copy the current immutable object by setting a value for the `implementationVersion` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for implementationVersion
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanLayerProperties` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `name`, `description`, `specificationVersion`, `implementationVersion`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanLayerProperties` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanLayerProperties of(String name, String description, int specificationVersion, int implementationVersion)
    Construct a new immutable `VulkanLayerProperties` instance.
    Parameters:
      `name` - The value for the `name` attribute
      `description` - The value for the `description` attribute
      `specificationVersion` - The value for the `specificationVersion` attribute
      `implementationVersion` - The value for the `implementationVersion` attribute
    Returns:
      An immutable VulkanLayerProperties instance

  - ### copyOf

    public static VulkanLayerProperties copyOf(VulkanLayerPropertiesType instance)
    Creates an immutable copy of a `VulkanLayerPropertiesType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanLayerProperties instance

  - ### builder

    public static VulkanLayerProperties.Builder builder()
    Creates a builder for `VulkanLayerProperties`.

         VulkanLayerProperties.builder()
            .setName(String) // required name
            .setDescription(String) // required description
            .setSpecificationVersion(int) // required specificationVersion
            .setImplementationVersion(int) // required implementationVersion
            .build();

    Returns:
      A new VulkanLayerProperties builder